#!  /bin/sh
#
#   Hyperpanel OS environment           File "stm32wl/exe/hypenv.sh"
#   Specific environment for stm32wl - STM32WL55JC1 - STM32WL55 Nucleo-64
#
#   Author : JYA/TE/FA                  Last modification : 19/07/2024
#

#   Syntax : Called by environment file.


# Some specific declarations --------------------------------------------------

  unalias -a                                            # Remove all alias.
                                                        #

# Commands paths --------------------------------------------------------------    
  PATH="."                                              # Commands paths. 
  PATH="$PATH:/usr/local/sbin:/usr/local/bin"           # Commands paths.  
  PATH="$PATH:/opt/STM/gcc-arm-none-eabi-10.3/bin"      # Commands paths.
  PATH="$PATH:/usr/sbin:/usr/bin"                       # Commands paths.  
  PATH="$PATH:/sbin:/bin"                               # Commands paths.  
  PATH="$PATH:$hlocal/$hboard/exe"                      # Commands paths.  
  PATH="$PATH:$hhome/boards/$hboard/exe"                # Commands paths.   
  PATH="$PATH:$hhome/shells"                            # Commands paths.  
  PATH="$PATH:$hhome/tools/bin"                         # Commands paths.  


# Include files paths ---------------------------------------------------------

  export hinclude="-I/usr/include"                        # Linux files
  export hinclude="$hinclude -I$hhome/os/include"         # HypOS files
  export hinclude="$hinclude -I$hhome/os/package"         # Include files path.
  export hinclude="$hinclude -I$hhome/os/vmk/lib"         # User libraries
  export hinclude="$hinclude -I$hhome/boards/$hboard/src" # Board related
  export hinclude="$hinclude -I/opt/STM/gcc-arm-none-eabi-10.3/lib/gcc/arm-none-eabi/10.3.1/include"
  export hinclude="$hinclude -I/usr/lib/gcc/$heabi/include"


# Defines directives ----------------------------------------------------------

  export hdef=""                                        # Defines.


# Compiler / linker directives ------------------------------------------------

# GCC generates incorrect code for "headbloc" (drv.c) as soon as optimization
# level is 1,2 or 3. As we do not know if this may happen with other codes
# then we use -O0
 
  export hcc="arm-none-eabi-gcc"                        # Compiler command.
  export hamm="arm-none-eabi-as"                        # Assembly compiler.
  export har="arm-none-eabi-ar"                         # Archive builder.
  export hlnk="arm-none-eabi-ld"                        # Linker command.
  export hocp="arm-none-eabi-objcopy"                   # Binary converter.
  export hnm="arm-none-eabi-nm"                         # Object analyzer.
  export hod="arm-none-eabi-objdump"                    # Object analyzer.
  export hnmpre=""                                      # Symbol prefix for nm.
                                                        #
  hop="-fno-strict-aliasing"                            # Compiler options.
  hop="$hop -fsigned-char"                              # Compiler options.
  hop="$hop -fno-builtin"                               # Compiler options.
  hop="$hop -nostdinc"                                  # Compiler options.
  hop="$hop -Wall"                                      # Compiler options.
  hop="$hop -Wno-missing-braces"                        # Compiler options.
  hop="$hop -Wno-unused-function"                       # Compiler options.
  hop="$hop -Wno-maybe-uninitialized"                   # Compiler options.
  hop="$hop -mcpu=cortex-m4"                            # Compiler options.
  hop="$hop -mtune=cortex-m4"                           # Compiler options.
  hop="$hop -mfpu=fpv4-sp-d16"                          # Compiler options.
  hop="$hop -mlittle-endian"                            # Compiler options.
  hop="$hop -mthumb"                                    # Compiler options.
  hop="$hop -mfloat-abi=hard"                           # Compiler options.
  hop="$hop -fsingle-precision-constant "               # Compiler options.
  hop="$hop -fdata-sections -ffunction-sections"        # Compiler options.
                                                        #
  hgdb="arm-none-eabi-gdb"                              # ARM debugger.
  hgdb="$hgdb -nh"                                      # Ignore cmd from home.
  hgdb="$hgdb -nx"                                      # Ignore cmd from file.
  hgdb="$hgdb -x $hhome/boards/$hboard/exe/gdb.cfg"     # Config. file for dbg.
                                                        #
  export hgdb                                           # Debugger.
                                                        #
  export hoptstd="-c -g -O0 $hop"                       # Standard mode.
  export hoptdbg="-c -gdwarf-4 -g3 -O0 $hop"            # Debug mode.
                                                        #
  export haopt="-g"                                     # Assembler options.
  export haopt="$haopt -mcpu=cortex-m4"                 # Assembler options.
  export haopt="$haopt -mlittle-endian"                 # Assembler options.
  export haopt="$haopt -mthumb"                         # Assembler options.
                                                        #
  export hlopt="-nostdlib --cref --warn-common --gc-sections" # Linker options.
# export hlopt="$hlopt --print-gc-sections"             # Linker options.
                                                        #
  export hlib="-L/opt/STM/gcc-arm-none-eabi-10.3/lib/gcc/arm-none-eabi/10.3.1"
  export hlib="-L/usr/lib/gcc/$heabi"                   # Additional libraries.
