/*****************************************************************************/
/*                                                                           */
/*  HyperPanel OS                       File "stm32wl/src/vm.s"              */
/*  Board - Assembly constants and definitions specific to stm32wl.          */
/*                                                                           */
/*  Author : TE                         Last modification : 17/11/2017       */
/*                                                                           */
/*  (c) Copyright HyperPanel Lab, All Rights Reserved                        */
/*  IDDN.FR.001.320001.*.S.P.1990.000.10000                                  */
/*                                                                           */
/*****************************************************************************/

/*****************************************************************************
 * This macro is used to define a procedure written in assembly language.    *
 * STM32 targets only support Thumb ISA.                                     *
 *****************************************************************************/

.macro MACRO_PROCEDURE name            /* Procedure definition ------------- */
    .section    .text  , "ax"          /* Code section                       */
    .thumb_func                        /* Thumb function.                    */
    \name :                            /* Procedure entry point              */
.endm                                  /* ---------------------------------- */

.macro MACRO_ENDPROC                   /* End of procedure ----------------- */
.endm                                  /* ---------------------------------- */

.macro MACRO_LABEL name                /* Label definition ----------------- */
    .thumb_func                        /* Thumb function.                    */
    \name :                            /* Procedure entry point              */
.endm                                  /* ---------------------------------- */

/*****************************************************************************
 * Macro needed by "vmit.c" - raise and lower one software aised IRQ         *
 *****************************************************************************/

.macro GPIO_VMIT_SET                   /* Unused on stm32wl.                 */
.endm

.macro GPIO_VMIT_RESET                 /* Unused on stm32wl.                 */
.endm

/*****************************************************************************
 * Macro needed by "int_cortex.s" - Sample the DWT counter and keep sample   *
 * in global "cycc_irq0"                                                     *
 *****************************************************************************/

.macro CYCC_IRQ0_GET                   /* Unused on stm32wl.                 */
.endm
