/*****************************************************************************/
/*                                                                           */
/*  Hyperpanel OS                       File "include/mem_buf.h"             */
/*  Constants and definitions for memory buffer.                             */
/*                                                                           */
/*  Author : JYA                        Last modification : 03/30/2021       */
/*                                                                           */
/*****************************************************************************/


/*  Some explanations ========================================================


         1  Defines
         2  Structures and typedefs
         3  Public variables
         4  Prototypes of public procedures

*/


#ifndef MEM_BUF_H                      /* If this file is not already        */
#define MEM_BUF_H                      /* included, include it.              */


/*
    1    Defines
    ____________
*/

/*
    2    Structures and typedefs
    ____________________________
*/

/*
    3    Public variables
    _____________________
*/


/*
    4    Prototypes of public procedures
    ____________________________________
  
    4.1  API procedures
    -------------------
*/

IWORD prealloc_buf        (INT,INT,INT,INT                                   );
IWORD alloc_buf           (INT,INT,INT,UCHAR**                               );
IWORD realloc_buf         (INT,UCHAR**,INT,INT                               );
IWORD post_buf            (UCHAR*,INT                                        );
IWORD free_buf            (UCHAR*,INT                                        );
IWORD alloc_aligned_buf   (INT,INT,INT,INT,INT,INT,INT,UCHAR**,INT*          );
IWORD get_buf_size        (UCHAR*,INT*,INT*,INT*                             );
IWORD get_buf_part        (UCHAR*,INT*                                       );
IWORD set_buf_posnb       (UCHAR*,INT,INT                                    );


#endif                                 /* End of MEM_BUF_H.                  */
